angular.module('focaModalLocalizar')
    .controller('focaModalLocalizarController', 
        [
            '$scope',
            '$uibModalInstance',
            'focaModalLocalizarService',
            'focaModalService',
            'parametros',
            function($scope, $uibModalInstance,
                focaModalLocalizarService, focaModalService, parametros) {

                $scope.latitud = parametros.latitud || -32.89214159952345;
                $scope.longitud = parametros.longitud || -68.84572999101856;
                $scope.localizar = !! parametros.direccion;

                if (parametros.direccion) {
                    focaModalLocalizarService
                        .getLatLng({
                            street: parametros.direccion.numero + ' ' + parametros.direccion.calle,
                            country: 'Argentina',
                            city: parametros.direccion.provincia,
                            county: parametros.direccion.localidad,
                            format: 'json'
                        })
                        .then(function(res) {
                            if (res.data.length) {
                                $scope.latitud = res.data[0].lat;
                                $scope.longitud = res.data[0].lon;
                                $scope.$broadcast('moveMap', {
                                    latitud: $scope.latitud,
                                    longitud: $scope.longitud
                                });
                            } else {
                                focaModalService.alert('No se pudo localizar el domicilio');
                            }
                        });
                }

                $scope.cancel = function() {
                    $uibModalInstance.dismiss();
                };

                $scope.aceptar = function() {
                    $uibModalInstance.close({
                        latitud: $scope.latitud,
                        longitud: $scope.longitud
                    });
                };
            }
        ]
    );
